/**
  *  \file planetscentral/net/smtp.h
  *  \brief Networking: SMTP
  */
#ifndef C2SERVER_PLANETSCENTRAL_NET_SMTP_H
#define C2SERVER_PLANETSCENTRAL_NET_SMTP_H

#include "planetscentral/dbclient/connection.h"

class MimeBuilder;

/** SMTP client. Provides routines to send mail to a mail server
    (smarthost, MTA). */

class Smtp : public Connection {
    void readReply(int expect);
    void write(const string_t& command);
    
 public:
    static bool checkConfig(string_t key, string_t value);

    static string_t getFrom();
    static string_t getFqdn();
    
    void sendMail(string_t from, string_t to, MimeBuilder& content);
};

#endif
