/**
  *  \file planetscentral/nntp/iothread.h
  */
#ifndef C2SERVER_PLANETSCENTRAL_NNTP_IOTHREAD_H
#define C2SERVER_PLANETSCENTRAL_NNTP_IOTHREAD_H

#include <vector>
#include <memory>
#include "cpluslib/ptrvector.h"
#include "planetscentral/osutil.h"

class Worker;

class IOThread {
 public:
    IOThread();
    ~IOThread();

    void start();
    void stop();
    void addWorker(int fd, Worker* worker);

 private:
    pthread_t handle;
    int wake_pipe[2];

    bool started;
    bool terminating;

    static void* entry(void*);
    void run();
    void processFinishedWorkers();
    void processNewWorkers();

    struct Info {
        std::auto_ptr<Worker> worker;
        int fd;
        int status;
    };
    ptr_vector<Info> workers;
    ptr_vector<Info> new_workers;
    Mutex mutex;

    enum {
        EndOfInput  = 1,
        EndOfOutput = 2
    };
};

#endif
